#include <stdint.h>

#include "rand.hh"
#include "stream.hh"

static unsigned long Seed = 0x00050000;

BAS_DBL  B_FuncRND(int n)
{
    // n < 0     : generates a number corresponding that value
    // n > 0 or
    // n omitted : next number in sequence
    // n = 0     : returns last number generated
    
    if(n > 0)
    {
        // generate new
        Seed = (Seed * 214013 + 2531011) & 0x00FFFFFF;
    }
    else if(n < 0)
    {
        // reseed for n
        n += (n >> 24);
        Seed = n & 0x00FFFFFF;
    }
    return Seed / (double)(1 << 24);
}

void B_StmtRANDOMIZE(BAS_DBL n)
{
    const uint_least16_t* words = (const uint_least16_t*) (&n);
    
    unsigned mask = words[2] ^ words[3];
    B_RANDOMIZE(mask);
}

void B_RANDOMIZE(int i)
{
    Seed = (Seed & ~0xFFFF00u) | ((i & 0xFFFF) << 8);
}

void B_StmtRANDOMIZE()
{
    /* TODO:
        INPUT "Random Number Seed (-32768 to 32767)?"; seed
        Seed = (Seed & 0xFF0000FFu) | seed
      */
    InputStreamBase& i = GET_STDIN();
    PrintStreamBase& o = GET_STDOUT();
    BAS_INT result = 0;
    for(;;)
    {
        o << "Random Number Seed (-32768 to 32767)? ";
        i.BeginInput();
        i.InputTo(result);
        if(i.EndInputOkp()) break;
        o << i.GetRedoMsg();
    }
    o.DoCRLF();
    B_RANDOMIZE(result);
}
